use std::path::PathBuf;

use crate::{grpc_client::GrpcClientState, models::ProjectTag, project_file, state::ClientState};

#[derive(clap::Parser, Debug)]
pub struct PublishCommand {
    #[arg(value_parser = clap::value_parser!(ProjectTag))]
    project_tag: ProjectTag,

    #[arg(long = "project-path", default_value = ".")]
    project_path: PathBuf,
}

impl PublishCommand {
    #[tracing::instrument(skip(state), level = "trace")]
    pub async fn execute(&self, state: &ClientState) -> anyhow::Result<()> {
        tracing::debug!("running norun publish");

        let project_file = project_file::parse_file(&self.project_path).await?;

        // FIXME: 2. Load resources
        state.grpc_client().publish(&project_file).await?;

        Ok(())
    }
}
